SoVertexAttributeBinding(3)

NAME
SoVertexAttributeBinding - The SoVertexAttributeBinding class is a node for setting up how vertex attributes are mapped to shapes.

SYNOPSIS

#include <Inventor/nodes/SoVertexAttributeBinding.h>

Inherits SoNode.

  Public Types
enum Binding { OVERALL = SoVertexAttributeBindingElement::OVERALL, PER_VERTEX = SoVertexAttributeBindingElement::PER_VERTEX, PER_VERTEX_INDEXED = SoVertexAttributeBindingElement::PER_VERTEX_INDEXED, DEFAULT = PER_VERTEX_INDEXED }

  Public Member Functions
virtual SoType getTypeId (void) const
SoVertexAttributeBinding (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFEnum value

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVertexAttributeBinding ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVertexAttributeBinding class is a node for setting up how vertex attributes are mapped to shapes.

See also
    SoVertexAttribute

The material binding specified in nodes of this type decides how the vertex attribute values of SoVertexAttribute nodes are mapped on the built-in geometry shape nodes.

Here is a simple usage example:

#Inventor V2.1 ascii
ShaderProgram {
  shaderObject [
    VertexShader {
      sourceProgram 'vertex.glsl'
    }
  ]
}
Coordinate3 {
  point [ 0 0 0, 1 0 0, 1 1 0 ]
}
VertexAttributeBinding { value OVERALL }
VertexAttribute {
  typeName 'SoMFVec3f'
  name 'color'
  values [ 1.0 0.0 0.0 ]
}
IndexedFaceSet {
  coordIndex [ 0, 1, 2, -1 ]
}

The vertex shader (vertex.glsl):

attribute vec3 color;
void main(void)
{
  gl_Position = ftransform();
  fragcolor = color;
}

With SoVertexAttributeBinding::value set to PER_VERTEX_INDEXED above, the attribute indices will be taken from the SoIndexedFaceSet::coordIndex field when rendering.

If SoVertexAttributeBinding::value is set to PER_VERTEX, attributes will be fetched in a monotonically increasing manner from the SoVertexAttribute::value field, starting at index 0.

If SoVertexAttributeBinding::value is set to OVERALL, the first attribute value from SoVertexAttribute::value will be sent to OpenGL before rendering.

FILE FORMAT/DEFAULTS:

VertexAttributeBinding {
    value PER_VERTEX_INDEXED
}

See also
    SoVertexAttribute Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
    Coin 3.0

Member Enumeration Documentation

  enum SoVertexAttributeBinding::Binding
Enumeration of available types of material binding.

Enumerator

OVERALL
    Apply the same material to the complete shape.

PER_VERTEX
    Get a new material from the pool of material values for each polygon, line or point vertex of the shape.

Attributes are fetched from index 0 and onwards, incrementing the index into the attribute pool by 1 for each new vertex of the shape node.

PER_VERTEX_INDEXED
    Get a new attribute from the pool of attribute values for each polygon, line or point vertex of the shape.

Attributes are fetched by the index value settings of the shape.

Constructor & Destructor Documentation

  SoVertexAttributeBinding::SoVertexAttributeBinding (void)
Constructor.

  SoVertexAttributeBinding::~SoVertexAttributeBinding () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVertexAttributeBinding::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVertexAttributeBinding::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoVertexAttributeBinding::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVertexAttributeBinding::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVertexAttributeBinding::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVertexAttributeBinding::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVertexAttributeBinding::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoVertexAttributeBinding::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoVertexAttributeBinding::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

Member Data Documentation

  SoSFEnum SoVertexAttributeBinding::value
The attribute binding to use for subsequent shape nodes in the scene graph. The default binding is SoVertexAttributeBinding::PER_VERTEX_INDEXED

Author

Generated automatically by Doxygen for Coin from the source code.